// wifictrl.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

#define		WLAN_POWON_EVENT		_T("WLanPowOn")
#define		WLAN_POWOFF_EVENT		_T("WLanPowOff")
#define		WLAN_REG_KEY_NAME		_T("System\\State\\Hardware")
#define		WLAN_REG_VALUE_NAME		_T("Wifi")
#define		WLAN_MUTEX_NAME			_T("WifiCtrl Mutex")
#define		WLAN_OPTION_ON			_T("on")
#define		WLAN_OPTION_OFF			_T("off")

#define		WIFI_STATE_POWERON		0x00000002
#define		WIFI_STATE_CONNECTING	0x00000008
#define		WIFI_STATE_CONNECTED	0x00000010


BOOL
SetWLan(int iOn)
{
	BOOL	bRet   = FALSE;
	HANDLE	hEvent = NULL;

	if (iOn) {
		hEvent = CreateEvent(NULL, 0, FALSE, WLAN_POWON_EVENT);
	}
	else {
		hEvent = CreateEvent(NULL, 0, FALSE, WLAN_POWOFF_EVENT);
	}

	if (hEvent != NULL) {
		SetEvent(hEvent);
		CloseHandle(hEvent);
		hEvent = NULL;
		bRet = TRUE;
	}

	return bRet;
}

int
GetWLan()
{
	int	iRet;
	LONG lResult;
	HKEY hKey;

	iRet = -1;

	lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, WLAN_REG_KEY_NAME, 0, 0, &hKey);
	if (lResult == ERROR_SUCCESS) {
		DWORD	dwType;
		DWORD	dwData;
		DWORD	dwSize;

		dwSize = sizeof(dwData);
		lResult = RegQueryValueEx(hKey, WLAN_REG_VALUE_NAME, NULL, &dwType, (LPBYTE)&dwData, &dwSize);

		if (lResult == ERROR_SUCCESS) {
			if (dwData & WIFI_STATE_POWERON) {
				iRet = 1;
			}
			else {
				iRet = 0;
			}
		}
		else {
			// WXgl擾łȂꍇOFFƂ
			iRet = 0;
		}
		RegCloseKey(hKey);
		hKey = NULL;
	}

	return iRet;
}

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{

	int	iCurrent;
	HANDLE	hMutex = NULL;

	hMutex = CreateMutex(NULL, TRUE, WLAN_MUTEX_NAME);
	if (hMutex != NULL) {
		if (GetLastError() == ERROR_ALREADY_EXISTS) {
			CloseHandle(hMutex);
			hMutex = NULL;
			return FALSE;
		}
	}
	else {
		return FALSE;
	}

	iCurrent = GetWLan();

	if (iCurrent < 0) {
		;
	}
	else {
		if (lpCmdLine != NULL && wcscmp(lpCmdLine, WLAN_OPTION_ON) == 0) {
			if (iCurrent != 1) {
				SetWLan(1);
			}
		}
		else if (lpCmdLine != NULL && wcscmp(lpCmdLine, WLAN_OPTION_OFF) == 0) {
			if (iCurrent != 0) {
				SetWLan(0);
			}
		}
		else {
			if (iCurrent == 0) {
				SetWLan(1);
			}
			else {
				SetWLan(0);
			}
		}
	}

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);
	hMutex = NULL;
	return 0;
}

